#include <sys/ioctl.h>
#include <unistd.h>
#include <time.h>
#include <sys/mman.h>
#include <string.h>
#include <malloc.h>
#include <fcntl.h>
#include <error.h>
#include <pthread.h>
#include "channels.h"

#define CHUNKSIZE 4096



int filesystemrd (struct _Channel *ch, unsigned char *buf, unsigned int len);
int filesystemdstr (struct _Channel *ch);



Channel *
filesystemch (const char *filestart)
{
  int x;

  struct M_filesystem *filez;
    struct transsound tss;
  Channel *ch;

  int i;





  ch = malloc (sizeof (Channel));
  filez = malloc (sizeof (struct M_filesystem));
  /*  tss=malloc (sizeof (struct transsound));*/


  srandom (time (0) * getpid ());
  /*  filez->dir=malloc(1024*sizeof(char));            */
  (struct dirent *) filez->entry = malloc (sizeof (struct dirent));

  /*  filez->rdbuf=malloc(BUFFERSIZE);
  filez->wrbuf=malloc(BUFFERSIZE);
  filez->wrbuf2=malloc(BUFFERSIZE);*/


  strcpy (filez->dir, filestart);
  filez->flg = 0;
  filez->flg2 = 0;
  filez->flg3 = 0;
  filez->first=0; 
  filez->endcount=0;
  filez->ending=0;
  filez->stop=0;
  getnextfile (filez, 1);

  ch->mirrorname=3;
  ch->rd = &filesystemrd;
  ch->destroy = &filesystemdstr;
  ch->data = filez;

inittranssound(&tss);



   filez->data=&tss;

   return ch;

}



int
getnextfile (struct M_filesystem *filez, int z)
{

  static int x;
  if (z == 1 || filez->flg == 1) {
    if (filez->flg3 == 1) {
      close (filez->fd);
      closedir (filez->dp);
      /*printf("closing");*/
      filez->flg3 = 0;
    }
    filez->flg = 0;

    if ((filez->dp = opendir (filez->dir)) == NULL) {
      /*perror("error");*/
      strcpy (filez->dir, "..");
      filez->flg3 = 1;
      filez->flg = 1;
 return 1;
}
    filez->flg2 = 0;

    chdir (filez->dir);
  }
  if ((filez->entry = readdir (filez->dp)) != NULL) {

    stat (filez->entry->d_name, &filez->statbuf);

    if (S_ISDIR (filez->statbuf.st_mode)) {
      if (strcmp (".", filez->entry->d_name) == 0 ||
	  strcmp ("..", filez->entry->d_name) == 0)
return 1;

/* we have directory -- have we been here before -- if so return -> to where?)*/

      /* changing directory -> keep old directory now*/

      if ((rand () %20) == 0 && (strcmp (filez->entry->d_name, "dev") != 0) && (strcmp (filez->entry->d_name, "proc")!=0)) {

	strcpy (filez->dir, filez->entry->d_name);
	filez->flg2 = 1;
	filez->flg =1;
	filez->flg3 = 1;
/* is not directory */
	getnextfile (filez, 0);
      }
else {
strcpy(filez->dir,"..");
getnextfile(filez,0);
 }
   } else {

      /*dup2(filez->fd,oldfd);*/
/*      close (filez->fd);*/
      /*      if (access (filez->entry->d_name, R_OK) != 0) {*/
if (filez->fd>0) close(filez->fd);
      if (((int) filez->fd = open (filez->entry->d_name, O_RDONLY)) != -1) {
	/*printf(" opened: %s X ",filez->entry->d_name);*/
	/*g_log (0, G_LOG_LEVEL_DEBUG, "FILE: %s",filez->entry->d_name);*/
 
	filez->flg3 = 1;
	return 1;
	/*	}*/
      } else {
	/*dup2(oldfd,filez->fd);*/

	/*perror("FD:");*/
	strcpy (filez->dir, "..");

	/*if ((closedir(filez->dp))==-1) perror("closedir");*/
	filez->flg = 1;
	filez->flg3 = 1;
	 
	/*	g_log (0, G_LOG_LEVEL_DEBUG, "no fd %s\n", filez->entry->d_name);*/
	 
	getnextfile (filez, 0);
      }


    }

  }
  /* is readdir null - see if hit end of directory*/
  else {
    strcpy (filez->dir, "..");

    /*if ((closedir(filez->dp))==-1) perror("closedir");*/
    filez->flg3 = 1;
    filez->flg = 1;
  }

  return 1;
}

int
filesystemrd (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  int x,cnt=0; 
  struct M_filesystem * fc = ch->data;
    rdr(fc, len, buf);

}

int
filesystemdstr (struct _Channel *ch)
{
  struct M_filesystem *filez = (struct M_filesystem *) (ch->data);

  closedir (filez->dp);
  close (filez->fd);
  free (filez);
}

int rdr (struct M_filesystem * filez, int lenny, unsigned char * buf){
  int x, frag, count,lent,transflag;
  x=0; 
    count = 0;
    transflag=0;

        while (lenny > 0) {
	  /* g_log(0,G_LOG_LEVEL_DEBUG,"BLAH:%d %d",filez->stop,filez->fd);*/

      if (filez->stop<=0) {

	filez->ending=1;

while (filez->fd <= 0) {
	getnextfile (filez, 0);
      }
      }
      


	      if (filez->ending==1 && filez->endcount>0){


	filez->ending=0;

	/* if soundoutbuffer/mirrorfn exists */


	if (filez->cap1==1){
	if ((lent=transsound(filez->rdbuf, filez->data, filez->wrbuf,filez->endcount))>0){
	  g_log(0,G_LOG_LEVEL_DEBUG,"TRANS:%d",lent);
	    /*write -- update counter */
	    filez->nature=1; /* deals with sound*/
	    filez->length=lent; /*length of sound*/
	    filez->length1=lent;
	    /* copy to buf + update that counter */
	    transflag=1;

	}}
	else
	  if (filez->cap2==1){
	if ((lent=transvid(filez->rdbuf, filez->wrbuf2,filez->endcount))>0){
g_log(0,G_LOG_LEVEL_DEBUG,"TRANS:%d",lent);
	  filez->nature=2;
	  filez->length=lent;
	  filez->length2=lent;
	  transflag=1;


	
	}}
	/*	  g_log(0,G_LOG_LEVEL_DEBUG,"BLAH:%d",lent);*/
	filez->endcount=0;	    
	}
	      
if (lenny<CHUNKSIZE) frag=lenny;
else frag=CHUNKSIZE;
      
 if (transflag==1){
   while (filez->endcount<filez->length) {

if (filez->nature==1) memcpy(&buf[count],&filez->wrbuf[filez->endcount],frag);
 if (filez->nature==2) memcpy(&buf[count],&filez->wrbuf2[filez->endcount],frag);
 filez->endcount+=frag;
 lenny-=frag;
 count+=frag;
 if (lenny<=0) break;
 if (count>=lenny) break;

   }
   transflag=0;
   filez->endcount=0;

 }
else
      while ((filez->stop = read (filez->fd, &buf[count], frag)) >0)

      {
	if (filez->ending==0) memcpy(&filez->rdbuf[filez->endcount],&buf[count],frag);
	filez->endcount+=frag;
	if (filez->endcount>=(BUFFERSIZ-CHUNKSIZE)) {
	  filez->ending=1;
	  filez->stop=0;
	    
	}

if (filez->stop>0){      lenny -= frag;
      count += frag;
  if (lenny < CHUNKSIZE)
	frag = lenny;
      else
	frag = CHUNKSIZE;
  if (lenny<=0) break;
  if (count>=lenny) break;}
}
if (filez->stop<=0){ close(filez->fd);
filez->fd=-1; }  } }





